/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
interface CommandLineOptions {
    help: boolean;
    /**
     * If true, use Ivy LS, otherwise use legacy View Engine LS.
     */
    ivy: boolean;
    /**
     * If true, skips the running ngcc when using Ivy LS.
     */
    disableAutomaticNgcc: boolean;
    logFile?: string;
    logVerbosity?: string;
    logToConsole: boolean;
    ngProbeLocations: string[];
    tsProbeLocations: string[];
    includeAutomaticOptionalChainCompletions: boolean;
    includeCompletionsWithSnippetText: boolean;
    forceStrictTemplates: boolean;
}
export declare function parseCommandLine(argv: string[]): CommandLineOptions;
export declare function generateHelpMessage(argv: string[]): string;
export {};
