/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
import * as ts from 'typescript/lib/tsserverlibrary';
import * as lsp from 'vscode-languageserver';
import type { TextDocument } from 'vscode-html-languageservice';
import * as pugLs from 'pugjs-language-service';
/**
 * Convert PugDocumen errors into LSP diagnostics
 * @param pugDiagnostic
 */
export declare function pugDiagnosticToLspDiagnostic(pugDiagnostic: pugLs.PugDocument['error']): lsp.Diagnostic | undefined;
/**
 * Convert ts.Diagnostic to lsp.Diagnostic
 * @param tsDiag TS diagnostic
 * @param file Used to compute proper offset.
 */
export declare function tsDiagnosticToLspDiagnostic(tsDiag: ts.Diagnostic, file: ts.server.ScriptInfo | TextDocument): lsp.Diagnostic;
