"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._tsRelatedInformationToLspRelatedInformationScriptInfo = exports._lspPositionToTsPositionScriptInfo = exports._tsTextSpanToLspRangeScriptInfo = void 0;
const ts = __importStar(require("typescript/lib/tsserverlibrary"));
const lsp = __importStar(require("vscode-languageserver"));
const utils_1 = require("./utils");
function _tsTextSpanToLspRangeScriptInfo(scriptInfo, textSpan) {
    const start = scriptInfo.positionToLineOffset(textSpan.start);
    const end = scriptInfo.positionToLineOffset(textSpan.start + textSpan.length);
    // ScriptInfo (TS) is 1-based, LSP is 0-based.
    return lsp.Range.create(start.line - 1, start.offset - 1, end.line - 1, end.offset - 1);
}
exports._tsTextSpanToLspRangeScriptInfo = _tsTextSpanToLspRangeScriptInfo;
function _lspPositionToTsPositionScriptInfo(scriptInfo, position) {
    const { line, character } = position;
    // ScriptInfo (TS) is 1-based, LSP is 0-based.
    return scriptInfo.lineOffsetToPosition(line + 1, character + 1);
}
exports._lspPositionToTsPositionScriptInfo = _lspPositionToTsPositionScriptInfo;
function _tsRelatedInformationToLspRelatedInformationScriptInfo(scriptInfo, relatedInfo) {
    if (relatedInfo === undefined)
        return;
    const lspRelatedInfo = [];
    for (const info of relatedInfo) {
        if (info.file === undefined || info.start === undefined || info.length === undefined)
            continue;
        const textSpan = {
            start: info.start,
            length: info.length,
        };
        const location = lsp.Location.create((0, utils_1.filePathToUri)(info.file.fileName), _tsTextSpanToLspRangeScriptInfo(scriptInfo, textSpan));
        lspRelatedInfo.push(lsp.DiagnosticRelatedInformation.create(location, ts.flattenDiagnosticMessageText(info.messageText, '\n')));
    }
    return lspRelatedInfo;
}
exports._tsRelatedInformationToLspRelatedInformationScriptInfo = _tsRelatedInformationToLspRelatedInformationScriptInfo;
//# sourceMappingURL=scriptInfo.js.map