import * as ts from 'typescript/lib/tsserverlibrary';
import * as lsp from 'vscode-languageserver';
import { TextDocument } from 'vscode-languageserver-textdocument';
/**
 * Convert ts.TextSpan to lsp.TextSpan. TypeScript keeps track of offset using
 * 1-based index whereas LSP uses 0-based index.
 * @param scriptInfo Used to determine the offsets.
 * @param textSpan
 */
export declare function _tsTextSpanToLspRangeTextDocument(document: TextDocument, textSpan: ts.TextSpan): lsp.Range;
export declare function _lspPositionToTsPositionTextDocument(document: TextDocument, position: lsp.Position): number;
export declare function _lspRangeToTsPositionsTextDocument(document: TextDocument, range: lsp.Range): [number, number];
export declare function _tsRelatedInformationToLspRelatedInformationTextDocument(document: TextDocument, relatedInfo?: ts.DiagnosticRelatedInformation[]): lsp.DiagnosticRelatedInformation[] | undefined;
