"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._tsRelatedInformationToLspRelatedInformationTextDocument = exports._lspRangeToTsPositionsTextDocument = exports._lspPositionToTsPositionTextDocument = exports._tsTextSpanToLspRangeTextDocument = void 0;
const ts = __importStar(require("typescript/lib/tsserverlibrary"));
const lsp = __importStar(require("vscode-languageserver"));
const utils_1 = require("./utils");
/**
 * Convert ts.TextSpan to lsp.TextSpan. TypeScript keeps track of offset using
 * 1-based index whereas LSP uses 0-based index.
 * @param scriptInfo Used to determine the offsets.
 * @param textSpan
 */
function _tsTextSpanToLspRangeTextDocument(document, textSpan) {
    const positionStart = document.positionAt(textSpan.start);
    const positionEnd = document.positionAt(textSpan.start + textSpan.length);
    return lsp.Range.create(positionStart.line, positionStart.character, positionEnd.line, positionEnd.character);
}
exports._tsTextSpanToLspRangeTextDocument = _tsTextSpanToLspRangeTextDocument;
function _lspPositionToTsPositionTextDocument(document, position) {
    const { line, character } = position;
    // ScriptInfo (TS) is 1-based, LSP is 0-based.
    return document.offsetAt({ line: line + 1, character: character + 1 });
}
exports._lspPositionToTsPositionTextDocument = _lspPositionToTsPositionTextDocument;
function _lspRangeToTsPositionsTextDocument(document, range) {
    const start = _lspPositionToTsPositionTextDocument(document, range.start);
    const end = _lspPositionToTsPositionTextDocument(document, range.end);
    return [start, end];
}
exports._lspRangeToTsPositionsTextDocument = _lspRangeToTsPositionsTextDocument;
function _tsRelatedInformationToLspRelatedInformationTextDocument(document, relatedInfo) {
    if (relatedInfo === undefined)
        return;
    const lspRelatedInfo = [];
    for (const info of relatedInfo) {
        if (info.file === undefined || info.start === undefined || info.length === undefined)
            continue;
        const textSpan = {
            start: info.start,
            length: info.length,
        };
        const location = lsp.Location.create((0, utils_1.filePathToUri)(info.file.fileName), _tsTextSpanToLspRangeTextDocument(document, textSpan));
        lspRelatedInfo.push(lsp.DiagnosticRelatedInformation.create(location, ts.flattenDiagnosticMessageText(info.messageText, '\n')));
    }
    return lspRelatedInfo;
}
exports._tsRelatedInformationToLspRelatedInformationTextDocument = _tsRelatedInformationToLspRelatedInformationTextDocument;
//# sourceMappingURL=textDocument.js.map